!! Purpose: Powers of matrices
!!          A^0 = I (Identity matrix)
!!          A^1 = 
!!          -> works only for square matrix
!!
!! History: R. Barthel, Mar 2015, KIT, SCC

Program exercise2b_2
Implicit None

!! Declaration of variables
integer                           :: m,n,p  !! readin variables
integer                           :: i,j    !! counters
integer                           :: istat  !! integer for checking status
real, dimension(:,:), allocatable :: a      !! rank-2 array
real, dimension(:,:), allocatable :: a_orig !! rank-2 array to store initial version of a


!! Reading variables
write(*,*) 'Please enter the matrix dimension m'
read *, m
!! -> reading n is actually redundent since the way of 
!!    a_ij = a_ij**p is done via p-1 times a = matmul(a,a_orig)
write(*,*) 'Please enter the matrix dimension n'
read *, n
write(*,*) 'Please enter the exponent for computing the power of matrix'
read *, p

!! Checking all restrictions
if (p .lt. 0 .or. m .le. 0 .or. n .le. 0 .or. m .ne. n) THEN
   write(*,*) "ERROR: p<0 or m,n<=0 or m/=n. Your input (m,n,p) was: ",  m, n, p
   stop
end if

!! Allocation
allocate (a(m,n), a_orig(m,n), STAT=istat)
if (istat .ne. 0) then
   write(*,*) 'ERROR: Allocation failed -> exit!'
   stop
end if

!! Assigning values to a and printing 
forall (i=1:m, j=1:n)
   a(i,j) = real(i)/real(j)
end forall
write(*,*) 'Elements of assigned array:'
write(*,*) a

!! Do powers of matrices
if (p .eq. 0) then
   !! a) A^0 = identity matrix
   a = 0.0
   do i = 1, m
      a(i,i) = 1.0
   end do
else
   !! store original a matrix
   a_orig = a
   do i = 1, p-1
      a = matmul(a,a_orig)
   end do
end if

!! Printing 
write(*,*) 'Elements of ',p,'. power of array a'
write(*,*) a

!! Do not forget to deallocate!
deallocate(a, a_orig, STAT=istat)
if (istat .ne. 0) then
   write(*,*) 'WARNING: Deallocation failed -> exit!'
end if

End Program exercise2b_2
